﻿
init python:
    class crazy_eight_class:
        def __init__(self, name, cards = []):
            self.name = name
            self.cards = cards
            self.deck = []
            self.discarded = []
            self.turn = 0
        def deal(self, p):
            if len(p[0].hand) < 7 or len(p[1].hand) < 7:
                if len(p[0].hand) < len(p[1].hand):
                    p[0].hand.append(self.deck.pop(0))
                else:
                    p[1].hand.append(self.deck.pop(0))
        def start(self):
            self.discarded.append(self.deck.pop(0))
        def shuffle(self):
            renpy.random.shuffle(self.deck)
        def draw(self, p):
            p.hand.append(self.deck.pop(0))
        def play(self, c, h, n):
            if self.turn == 2:
                if c.number == 8 or c.suit == self.discarded[-1].suit or c.number == self.discarded[-1].number:
                    self.discarded.append(h.hand.pop(n))
                    self.turn = 3
                else:
                    msg.msg("Must be the same suit or rank or a crazy eight!")
            else:
                msg.msg("Wait for your turn!")
        def enemy_ai(self, h):
            for ii, i in enumerate(h.hand):
                if i.suit == self.discarded[-1].suit and i.number is not 8:
                    self.discarded.append(h.hand.pop(ii))
                    self.turn = 2
                    msg.msg("Your turn")
                    break
            else:
                for ii, i in enumerate(h.hand):
                    if i.number == self.discarded[-1].number and i.number is not 8:
                        self.discarded.append(h.hand.pop(ii))
                        self.turn = 2
                        msg.msg("Your turn")
                        break
                else:
                    for ii, i in enumerate(h.hand):
                        if i.number == 8:
                            self.discarded.append(h.hand.pop(ii))
                            self.turn = 2
                            msg.msg("Your turn")
                            break
                    else:
                        if len(self.deck):
                            self.draw(h)
                        else:
                            self.turn = 2
                            msg.msg("Your turn")

        def next(self, t):
            self.turn = t
        def reset(self, p):
            for i in p:
                i.hand = []
            self.deck = self.cards.copy()
            self.discarded = []
            self.shuffle()
            self.turn = 0



default crazy_eight_ins = crazy_eight_class("Crazy Eight", all_cards)


transform crazy_eight_ani(x = 0):
    rotate_pad False
    alpha 0 rotate renpy.random.randint(45,180) xoffset x
    ease .2 alpha 1.0 rotate renpy.random.randint(-1,1) xoffset 0
    on idle:
        ease .2 yoffset 0
    on hover:
        ease .2 yoffset -100
    



screen crazy_eight(p = [c_player, c_computer], g = crazy_eight_ins):
    modal True

    if g.turn == 0:
        timer .01 action Function(g.reset, p)
        frame:
            vbox:
                text "Are you ready to play {}?".format(g.name)
                hbox:
                    button:
                        text "Let's dance!"
                        action Function(g.next, 1)
                    button:
                        text "What is {}?".format(g.name)
                        action ToggleScreen("crazy_eight_help")
    elif g.turn == 1:
        timer .01 action Function(g.shuffle)
        if len(p[0].hand) < 7 or len(p[1].hand) < 7:
            timer .1 repeat True action Function(g.deal, p)
        else:
            timer .1 action Function(g.start)
            timer .2 action Function(g.next, 2)
    elif g.turn == 2:
        button:
            xalign .08
            text "pass"
            action Function(g.next, 3)
    elif g.turn == 3:
        timer .5 repeat True action Function(g.enemy_ai, p[1])


    # deck
    if len(g.deck) > 1:
        add "cards_1/back.png" at crazy_eight_ani xalign .02
    if len(g.deck):
        button:
            padding 0,0 background None xalign .02
            at crazy_eight_ani
            add "cards_1/back.png"
            action Function(g.draw, p[0])

    # discarded pile
    if len(g.discarded):
        add "cards_1/{}/{}.png".format(g.discarded[-1].suit, g.discarded[-1].number) xalign .98 at crazy_eight_ani(-1600)
    # player's hand
    hbox:
        spacing -180 yalign 0.95 
        # text p[0].name
        for ii, i in enumerate(p[0].hand):
            button:
                padding 0,0 background None
                at crazy_eight_ani
                add "cards_1/{}/{}.png".format(i.suit, i.number)
                action Function(g.play, i, p[0], ii)

    # enemy's hand
    hbox:
        at bzoom(.5) yalign 0.05 spacing -180
        # text p[1].name
        for i in p[1].hand:
            add "cards_1/back.png" at crazy_eight_ani


    if len(p[0].hand) == 0 and g.turn in [3, 2]:
        button:
            background None
            action NullAction()
        
        frame:
            vbox:
                text "You're good at {}! You won!\nDo you want to play again?".format(g.name)
                hbox:
                    button:
                        text "Sure!"
                        action Function(g.reset, p)
                    button:
                        text "How is {} played again?".format(g.name)
                        action ToggleScreen("crazy_eight_help")
                    button:
                        text "Not really."
                        action Hide("crazy_eight")
    if len(p[1].hand) == 0 and g.turn in [3, 2]:
        button:
            background None
            action NullAction()
        
        frame:
            vbox:
                text "Ha ha, you lost!\nDo you want to play again?".format(g.name)
                hbox:
                    button:
                        text "Sure!"
                        action Function(g.reset, p)
                    button:
                        text "How is {} played again?".format(g.name)
                        action ToggleScreen("crazy_eight_help")
                    button:
                        text "No! Screw {}!".format(g.name)
                        action Hide("crazy_eight")

screen crazy_eight_help:
    button:
        background None
        action Hide("crazy_eight_help")
    frame:
        xsize 1200
        text "Each player is dealt seven cards.\nThe remaining cards are placed face down in the center of the table, forming a draw pile.\nThe top card of the draw pile is turned face up to start the discard pile next to it.\nFirst player adds to the discard pile by playing one card that matches the top card on the discard pile either by suit or by rank (i.e. 6, jack, ace, etc.).\nA player who cannot match the top card on the discard pile by suit or rank must draw cards until he can play one.\nWhen the draw pile is empty, a player who cannot add to the discard pile passes his turn.\nAll eights are wild and can be played on any card during a player's turn.\nWhen a player discards an eight, he chooses which suit is now in play.\nThe next player must play either a card of that suit or another eight.\nThe first player to discard all of his cards wins." size 30
